"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _runtimeType = _interopRequireDefault(require("runtime-type"));

var _smartError = _interopRequireDefault(require("smart-error"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Shape = /*#__PURE__*/function () {
  /** @type {Field[]} */

  /** @type {Type.Type} */

  /**
   * @param {string} name
   * @param {string} description
   * @param {Field[]} fields 
   */
  function Shape(name, description) {
    var _this = this;

    _classCallCheck(this, Shape);

    _defineProperty(this, "name", null);

    _defineProperty(this, "description", null);

    _defineProperty(this, "fields", []);

    _defineProperty(this, "type", _runtimeType["default"].any);

    this.name = name;

    for (var _len = arguments.length, fields = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
      fields[_key - 2] = arguments[_key];
    }

    if (description instanceof Field) {
      fields.unshift(description);
      this.description = null;
    } else {
      this.description = description;
    }

    this.fields = fields;
    var shape = {};
    this.fields.forEach(function (field) {
      shape[_this._getFieldName(field)] = field.type;
    });
    this.type = _runtimeType["default"].shape(shape);
  }

  _createClass(Shape, [{
    key: "toJSON",
    value: function toJSON() {
      var o = {
        name: this.name,
        description: this.description,
        shape: {},
        type: this.type.toString()
      };
      this.fields.forEach(function (field) {
        o.shape[field.name] = field;
      });
      return o;
    }
  }, {
    key: "_getFieldName",
    value: function _getFieldName(field) {
      if (field.required === undefined) {
        return field.name;
      }

      return field.required ? field.name : "".concat(field.name, "?");
    }
  }]);

  return Shape;
}();

var ShapeArray = /*#__PURE__*/function () {
  /** @type {Shape} */

  /** @type {Type.Type} */

  /**
   * 
   * @param {string} name 
   * @param {string} description 
   * @param {Field[]} shape 
   */
  function ShapeArray(name, description) {
    _classCallCheck(this, ShapeArray);

    _defineProperty(this, "name", null);

    _defineProperty(this, "description", null);

    _defineProperty(this, "shape", null);

    _defineProperty(this, "type", _runtimeType["default"].any);

    this.name = name;

    for (var _len2 = arguments.length, fields = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
      fields[_key2 - 2] = arguments[_key2];
    }

    if (description instanceof Field) {
      fields.unshift(description);
      this.description = null;
    } else {
      this.description = description;
    }

    this.shape = _construct(Shape, ['__shape__', null].concat(fields));
    this.type = _runtimeType["default"].arrayOf(this.shape.type);
  }

  _createClass(ShapeArray, [{
    key: "toJSON",
    value: function toJSON() {
      return {
        name: this.name,
        description: this.description,
        shape_array: this.shape.toJSON().shape,
        type: this.type.toString()
      };
    }
  }]);

  return ShapeArray;
}();

var Field = /*#__PURE__*/function () {
  /**
   * 
   * @param {string} name 
   * @param {Type.Type|string} type 
   * @param {string} description 
   */
  function Field(name) {
    var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _runtimeType["default"].any;
    var description = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

    _classCallCheck(this, Field);

    _defineProperty(this, "key", null);

    _defineProperty(this, "name", null);

    _defineProperty(this, "type", null);

    _defineProperty(this, "description", null);

    this.key = name;
    this.name = name;
    this.type = typeof type === 'string' ? _runtimeType["default"][type] : type;
    this.description = description;

    if (!(this.type instanceof _runtimeType["default"].Type)) {
      throw new _smartError["default"]('Invalid type.');
    }
  }

  _createClass(Field, [{
    key: "toJSON",
    value: function toJSON() {
      return {
        name: this.name,
        key: this.key,
        description: this.description,
        type: this.type.toString()
      };
    }
  }], [{
    key: "create",
    value: function create(param) {
      if (typeof param === 'string') {
        if (param.indexOf('.') > 0) {
          throw new _smartError["default"]('Cannot create shape parameter', 'no_shape');
        }

        return new this(param, _runtimeType["default"].any, null);
      }

      return new this(param.name, param.type, param.description);
    }
    /** @type {string} */

  }]);

  return Field;
}();

exports["default"] = Field;

_defineProperty(Field, "Shape", Shape);

_defineProperty(Field, "ShapeArray", ShapeArray);