"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Param", {
  enumerable: true,
  get: function get() {
    return _param["default"];
  }
});
Object.defineProperty(exports, "Field", {
  enumerable: true,
  get: function get() {
    return _field["default"];
  }
});
Object.defineProperty(exports, "ErrorField", {
  enumerable: true,
  get: function get() {
    return _errorField["default"];
  }
});
exports["default"] = void 0;

var _param = _interopRequireWildcard(require("./param"));

var _field = _interopRequireDefault(require("./field"));

var _error = _interopRequireDefault(require("../error"));

var _errorField = _interopRequireDefault(require("./error-field"));

var _response = require("../response");

var _invalidArgumentType = _interopRequireDefault(require("../error/errors/invalid-argument-type"));

var _invalidParameterType = _interopRequireDefault(require("../error/errors/invalid-parameter-type"));

var _invalidInputType = _interopRequireDefault(require("../error/errors/invalid-input-type"));

var _missingParameter = _interopRequireDefault(require("../error/errors/missing-parameter"));

var _missingApiKey = _interopRequireDefault(require("../error/errors/missing-api-key"));

var _invalidApiKey = _interopRequireDefault(require("../error/errors/invalid-api-key"));

var _missingAccessToken = _interopRequireDefault(require("../error/errors/missing-access-token"));

var _invalidAccessToken = _interopRequireDefault(require("../error/errors/invalid-access-token"));

var _timeout = _interopRequireDefault(require("../error/errors/timeout"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Endpoint = /*#__PURE__*/function () {
  /**
   * 
   * @param {*} route 
   * @param {Options} options 
   */
  function Endpoint(route) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Endpoint);

    _defineProperty(this, "version", null);

    _defineProperty(this, "auth", 0);

    _defineProperty(this, "params", null);

    _defineProperty(this, "response", null);

    _defineProperty(this, "errors", null);

    _defineProperty(this, "description", null);

    _defineProperty(this, "hideDocs", false);

    _defineProperty(this, "callback", null);

    _defineProperty(this, "route", null);

    _defineProperty(this, "deprecated", false);

    _defineProperty(this, "apiKeyEnabled", false);

    _defineProperty(this, "excludedApiKeys", []);

    _defineProperty(this, "timeout", null);

    _defineProperty(this, "props", {});

    _defineProperty(this, "args", {});

    this.version = options.version === undefined ? null : options.version;
    this.auth = options.auth || 0;
    this.params = _param.ParamParser.parse(options.params || []);
    this.response = options.response === undefined ? new _response.JSONResponse([]) : options.response;
    this.errors = (options.errors || []).map(function (e) {
      if (e instanceof _errorField["default"]) {
        return e;
      }

      if (e instanceof _error["default"]) {
        return e.toErrorField();
      }

      return new _errorField["default"](e);
    });
    this.description = options.description || null;
    this.hideDocs = options.hideDocs || false;
    this.callback = options.callback || null;
    this.apiKeyEnabled = options.apiKeyEnabled || false;
    this.excludedApiKeys = options.excludedApiKeys || [];
    this.timeout = options.timeout || null;
    this.props = options.props || {};
    this.args = this._mergeArguments(route, options.args);

    if (options.validateParams) {
      this._validateParams();
    }

    if (route) {
      route.addEndpoint(this);
    }

    this._setErrors();
  }

  _createClass(Endpoint, [{
    key: "requiredParams",
    get:
    /**
     * @typedef Options
     * @property {number?} version
     * @property {number?} auth
     * @property {boolean} requireAuth
     * @property {Param[]|string[]} params
     * @property {BaseResponse} response
     * @property {string[]|ErrorField[]|RSError[]} errors
     * @property {string} description
     * @property {boolean} hideDocs
     * @property {function} callback
     * @property {boolean} validateParams
     * @property {boolean} apiKeyEnabled
     * @property {string[]|function} excludedApiKeys
     * @property {number} timeout
     * @property {any} props
     * @property {Field[]} args
     */

    /** @type {Param[]} */

    /** @type {BaseResponse} */

    /** @type {ErrorField[]} */

    /** 
     * @type {string[]}
     * @deprecated 
     */
    function get() {
      return this.params.filter(function (param) {
        return param.required;
      }).map(function (param) {
        return param.name;
      });
    }
    /**
     * @type {string}
     * @deprecated
     */

  }, {
    key: "docs",
    get: function get() {
      return this.description;
    }
  }, {
    key: "requiredAuth",
    get: function get() {
      switch (this.auth) {
        case 2:
          return true;

        default:
          return false;
      }
    }
  }, {
    key: "getEndpoint",
    value: function getEndpoint() {
      if (this.version === null) {
        return this.route.route;
      }

      return "/".concat(this.version).concat(this.route.route);
    }
  }, {
    key: "getParams",
    value: function getParams() {
      var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (array) {
        return this.params;
      }

      var o = {};
      this.params.forEach(function (p) {
        return o[p.name] = p;
      });
      return o;
    }
  }, {
    key: "getResponse",
    value: function getResponse() {
      var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      return this.response ? this.response.get(array) : null;
    }
  }, {
    key: "getResponseType",
    value: function getResponseType(charset) {
      return this.response ? this.response.getContentType(charset) : null;
    }
  }, {
    key: "getArguments",
    value: function getArguments() {
      var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (array) {
        return this.args;
      }

      var o = {};
      this.args.forEach(function (a) {
        return o[a.name] = a;
      });
      return o;
    }
  }, {
    key: "getRouteArguments",
    value: function getRouteArguments() {
      if (!this.route) {
        return {};
      }

      return this.route.args;
    }
  }, {
    key: "getErrors",
    value: function getErrors() {
      var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (array) {
        return this.errors;
      }

      var o = {};
      this.errors.forEach(function (p) {
        return o[p.code] = p.description;
      });
      return o;
    }
  }, {
    key: "getAuth",
    value: function getAuth() {
      switch (this.auth) {
        case 2:
          return 'REQUIRED';

        case 1:
          return 'OPTIONAL';

        default:
          return 'DISABLED';
      }
    }
  }, {
    key: "isDeprecated",
    value: function isDeprecated() {
      if (!this.route) {
        return false;
      }

      return this.deprecated || this.route.getMaxVersion() !== this.version;
    }
  }, {
    key: "isApiKeyExcluded",
    value: function () {
      var _isApiKeyExcluded = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(key) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(typeof this.excludedApiKeys === 'function')) {
                  _context.next = 4;
                  break;
                }

                _context.next = 3;
                return this.excludedApiKeys();

              case 3:
                return _context.abrupt("return", _context.sent.includes(key));

              case 4:
                return _context.abrupt("return", this.excludedApiKeys.includes(key));

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function isApiKeyExcluded(_x) {
        return _isApiKeyExcluded.apply(this, arguments);
      }

      return isApiKeyExcluded;
    }()
  }, {
    key: "deprecate",
    value: function deprecate() {
      this.deprecated = true;
      return this;
    }
  }, {
    key: "auth",
    value: function auth() {
      this.requiredAuth = true;
      return this;
    }
    /**
     * 
     * @param {string} docs 
     * @deprecated
     */

  }, {
    key: "setDocs",
    value: function setDocs(docs) {
      this.description = docs;
      return this;
    }
  }, {
    key: "_validateParams",
    value: function _validateParams() {
      var names = [];
      this.params.forEach(function (param) {
        if (names.indexOf(param.name) >= 0) {
          console.warn("Param with name '".concat(param.name, "' already exists. It can cause unpredictable effects."));
        }

        if (param.type.toString() === 'any') {
          console.warn("Param with name '".concat(param.name, "' is type of 'any'. It can cause unpredictable effects."));
        }
      });
    }
  }, {
    key: "_setErrors",
    value: function _setErrors() {
      var params = Boolean(this.params.length);
      var args = this.route && Object.keys(this.route.args).length;

      if (args && params) {
        this.errors.unshift(_invalidInputType["default"].toErrorField());
      } else if (params) {
        this.errors.unshift(_invalidParameterType["default"].toErrorField());
      } else if (args) {
        this.errors.unshift(_invalidArgumentType["default"].toErrorField());
      }

      if (this.requiredParams.length) {
        this.errors.unshift(_missingParameter["default"].toErrorField());
      }

      if (this.requiredAuth) {
        this.errors.unshift(_invalidAccessToken["default"].toErrorField());
        this.errors.unshift(_missingAccessToken["default"].toErrorField());
      }

      if (this.apiKeyEnabled) {
        this.errors.unshift(_invalidApiKey["default"].toErrorField());
        this.errors.unshift(_missingApiKey["default"].toErrorField());
      }

      if (this.timeout) {
        this.errors.unshift(_timeout["default"].toErrorField());
      }
    }
  }, {
    key: "_mergeArguments",
    value: function _mergeArguments(route) {
      var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

      if (route) {
        return route.getArguments(true).map(function (routeArg) {
          return args.find(function (_ref) {
            var name = _ref.name;
            return name === routeArg.name;
          }) || routeArg;
        });
      }

      return args;
    }
  }]);

  return Endpoint;
}();

exports["default"] = Endpoint;