"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _base = _interopRequireDefault(require("./base"));

var _invalidParameterType = _interopRequireDefault(require("./errors/invalid-parameter-type"));

var _invalidArgumentType = _interopRequireDefault(require("./errors/invalid-argument-type"));

var _invalidInputType = _interopRequireDefault(require("./errors/invalid-input-type"));

var _missingParameter = _interopRequireDefault(require("./errors/missing-parameter"));

var _missingApiKey = _interopRequireDefault(require("./errors/missing-api-key"));

var _invalidApiKey = _interopRequireDefault(require("./errors/invalid-api-key"));

var _invalidAccessToken = _interopRequireDefault(require("./errors/invalid-access-token"));

var _missingAccessToken = _interopRequireDefault(require("./errors/missing-access-token"));

var _timeout = _interopRequireDefault(require("./errors/timeout"));

var _notFound = _interopRequireDefault(require("./errors/not-found"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var RSError = /*#__PURE__*/function (_RSBaseError) {
  _inherits(RSError, _RSBaseError);

  var _super = _createSuper(RSError);

  function RSError() {
    _classCallCheck(this, RSError);

    return _super.apply(this, arguments);
  }

  return RSError;
}(_base["default"]);

exports["default"] = RSError;

_defineProperty(RSError, "InvalidParameterType", _invalidParameterType["default"]);

_defineProperty(RSError, "InvalidArgumentType", _invalidArgumentType["default"]);

_defineProperty(RSError, "InvalidInputType", _invalidInputType["default"]);

_defineProperty(RSError, "MissingParameter", _missingParameter["default"]);

_defineProperty(RSError, "MissingApiKey", _missingApiKey["default"]);

_defineProperty(RSError, "InvalidApiKey", _invalidApiKey["default"]);

_defineProperty(RSError, "InvalidAccessToken", _invalidAccessToken["default"]);

_defineProperty(RSError, "MissingAccessToken", _missingAccessToken["default"]);

_defineProperty(RSError, "Timeout", _timeout["default"]);

_defineProperty(RSError, "NotFound", _notFound["default"]);