"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Error", {
  enumerable: true,
  get: function get() {
    return _smartError["default"];
  }
});
Object.defineProperty(exports, "HttpError", {
  enumerable: true,
  get: function get() {
    return _httpSmartError["default"];
  }
});
Object.defineProperty(exports, "Type", {
  enumerable: true,
  get: function get() {
    return _runtimeType["default"];
  }
});
Object.defineProperty(exports, "TypeModel", {
  enumerable: true,
  get: function get() {
    return _runtimeType.Model;
  }
});
Object.defineProperty(exports, "Endpoint", {
  enumerable: true,
  get: function get() {
    return _endpoint["default"];
  }
});
Object.defineProperty(exports, "Param", {
  enumerable: true,
  get: function get() {
    return _endpoint.Param;
  }
});
Object.defineProperty(exports, "Field", {
  enumerable: true,
  get: function get() {
    return _endpoint.Field;
  }
});
Object.defineProperty(exports, "ErrorField", {
  enumerable: true,
  get: function get() {
    return _endpoint.ErrorField;
  }
});
Object.defineProperty(exports, "Response", {
  enumerable: true,
  get: function get() {
    return _response["default"];
  }
});
Object.defineProperty(exports, "RSError", {
  enumerable: true,
  get: function get() {
    return _error2["default"];
  }
});
Object.defineProperty(exports, "RouteAuth", {
  enumerable: true,
  get: function get() {
    return _enums.RouteAuth;
  }
});
exports.Application = exports["default"] = void 0;

require("@babel/polyfill");

var _express = _interopRequireDefault(require("express"));

var _compression = _interopRequireDefault(require("compression"));

var _bodyParser = _interopRequireDefault(require("body-parser"));

var _smartError = _interopRequireDefault(require("smart-error"));

var _httpSmartError = _interopRequireDefault(require("http-smart-error"));

var _routeParser = _interopRequireDefault(require("route-parser"));

var _runtimeType = _interopRequireWildcard(require("runtime-type"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _lodash = _interopRequireDefault(require("lodash"));

var _endpoint = _interopRequireWildcard(require("./endpoint"));

var _route = _interopRequireDefault(require("./route"));

var _benchmark = _interopRequireDefault(require("./benchmark"));

var _response = _interopRequireWildcard(require("./response"));

var _error2 = _interopRequireDefault(require("./error"));

var _enums = require("./typings/enums");

var _package = _interopRequireDefault(require("../package.json"));

var _missingApiKey = _interopRequireDefault(require("./error/errors/missing-api-key"));

var _invalidApiKey = _interopRequireDefault(require("./error/errors/invalid-api-key"));

var _invalidAccessToken = _interopRequireDefault(require("./error/errors/invalid-access-token"));

var _missingAccessToken = _interopRequireDefault(require("./error/errors/missing-access-token"));

var _timeout = _interopRequireDefault(require("./error/errors/timeout"));

var _notFound = _interopRequireDefault(require("./error/errors/not-found"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var APP_PACKAGE = require(_path["default"].resolve('./package.json'));
/** @type {import('./').IAppOptions} */


var DEFAULT_OPTIONS = {
  port: 8080,
  name: 'Resting Squirrel App',
  dataKey: 'data',
  errorKey: 'error',
  log: {
    enabled: true,
    level: 'verbose',
    stack: true
  },
  logStack: true,
  logger: function logger(_ref) {
    var statusCode = _ref.statusCode,
        method = _ref.method,
        path = _ref.path,
        spec = _ref.spec,
        body = _ref.body,
        params = _ref.params,
        query = _ref.query,
        headers = _ref.headers,
        took = _ref.took,
        response = _ref.response;
    console.log(new Date(), "".concat(statusCode, " ").concat(method, " ").concat(path, " BODY: ").concat(JSON.stringify(body), " QUERY: ").concat(JSON.stringify(query), " HEADERS: ").concat(JSON.stringify(headers), " TOOK: ").concat(took, " ms"));
    console.log('');
  },
  meta: {
    enabled: true,
    data: {}
  },
  requestLimit: '1mb',
  charset: 'utf-8',
  docs: {
    enabled: true,
    route: '/docs',
    auth: false,
    paramsAsArray: false
  },
  auth: {
    key: 'x-token',
    description: null,
    validator: function validator(key, req, res, next) {
      return new Promise(function (resolve) {
        return resolve(true);
      });
    }
  },
  apiKey: null,
  timeout: null,
  before: {
    '*': function _(req, res, next) {
      return next();
    }
  },
  after: {
    '*': function _(err, data, req, res, next) {
      return next();
    }
  },
  defaultError: {
    statusCode: 500,
    message: 'Server error',
    code: 'unknown'
  },
  validateParams: true,
  responseStrictValidation: false,
  wrapArrayResponse: false,
  errorStack: false
};

var Application = /*#__PURE__*/function () {
  /**
   * 
   * @param {import('./').IAppOptions} options 
   */
  function Application() {
    var _this = this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Application);

    _defineProperty(this, "_app", null);

    _defineProperty(this, "_server", null);

    _defineProperty(this, "_options", {});

    _defineProperty(this, "_routes", {});

    _defineProperty(this, "_beforeExecution", []);

    _defineProperty(this, "_afterExecution", []);

    _defineProperty(this, "_apiKeyHandler", null);

    _defineProperty(this, "_stats", {
      error: 0,
      warning: 0
    });

    this._options = this._mergeObjects(options, DEFAULT_OPTIONS);

    if (typeof options.log === 'boolean') {
      this._options.log = _objectSpread(_objectSpread({}, this._mergeObjects({}, DEFAULT_OPTIONS.log)), {}, {
        enabled: options.log
      });

      this._warn('Using log option as boolean is deprecated.');
    }

    if (typeof this._options.before === 'function') {
      this._warn('Using \'before\' as a functions is deprecated');

      this._options.before = {
        '*': this._options.before
      };
    }

    if (typeof this._options.after === 'function') {
      this._warn('Using \'after\' as a functions is deprecated');

      this._options.after = {
        '*': this._options.after
      };
    }

    if (this._options.before) {
      this._warn('Using \'before\' option is deprecated');

      Object.keys(this._options.before).forEach(function (route) {
        _this.registerBeforeExecution(route, function (req, res) {
          return new Promise(function (resolve, reject) {
            _this._options.before[route](req, res, function (err) {
              if (err) {
                reject(err);
                return;
              }

              resolve();
            });
          });
        });
      });
    }

    if (this._options.after) {
      this._warn('Using \'after\' option is deprecated.');

      Object.keys(this._options.after).forEach(function (route) {
        _this.registerAfterExecution(route, function (err, data, req, res) {
          return new Promise(function (resolve, reject) {
            _this._options.after[route](err, data, req, res, function (err) {
              if (err) {
                reject(err);
                return;
              }

              resolve();
            });
          });
        });
      });
    }

    if (this._options.apiKey) {
      this._warn('Using \'apiKey\' option is deprecated.');
    } // Object merge cannot merge not existing keys, so this adds custom meta data to the options.


    if (options.meta && options.meta.data) {
      Object.keys(options.meta.data).forEach(function (k) {
        return _this._options.meta.data[k] = options.meta.data[k];
      });
    }

    if (typeof options.auth === 'function') {
      this._warn('Using auth option as a function is deprecated.');

      this._options.auth = this._mergeObjects({}, DEFAULT_OPTIONS.auth);

      this._options.auth.validator = function (key, req, res, cb) {
        options.auth(req, res, cb);
      };
    }

    if (typeof options.logStack === 'boolean') {
      this._warn('Using logStack option is deprecated.');

      this._options.log.stack = options.logStack;
    }

    this._createApp();

    this._registerSupportRoutes();
  }

  _createClass(Application, [{
    key: "version",
    get:
    /** @type {express.Express} */

    /** @type {http.Server} */

    /** @type {import('./').IAppOptions} */

    /** @type {Object.<string, Route>} */
    function get() {
      return APP_PACKAGE.version;
    }
  }, {
    key: "use",
    value: function use(route, callback) {
      if (!callback) {
        this._app.use(route);

        return;
      }

      this._app.use(route, callback);
    } // #region Registers

  }, {
    key: "registerApiKeyHandler",
    value: function registerApiKeyHandler(handler) {
      this._apiKeyHandler = handler;
      return this;
    }
  }, {
    key: "registerBeforeExecution",
    value: function registerBeforeExecution(spec, callback) {
      var index = this._beforeExecution.map(function (_ref2) {
        var spec = _ref2.spec;
        return spec;
      }).indexOf(spec);

      if (index >= 0) {
        this._warn("Before execution callback for '".concat(spec, "' is already registered. Rewriting."));

        this._beforeExecution.splice(index, 1);
      }

      this._beforeExecution.push({
        spec: spec,
        callback: callback
      });

      return this;
    }
  }, {
    key: "registerAfterExecution",
    value: function registerAfterExecution(spec, callback) {
      var index = this._afterExecution.map(function (_ref3) {
        var spec = _ref3.spec;
        return spec;
      }).indexOf(spec);

      if (index >= 0) {
        this._warn("After execution callback for '".concat(spec, "' is already registered. Rewriting."));

        this._afterExecution.splice(index, 1);
      }

      this._afterExecution.push({
        spec: spec,
        callback: callback
      });

      return this;
    } // #endregion
    // #region HTTP methods

    /**
     * 
     * @param {number} version 
     * @param {string} route 
     * @param {import('./').IRouteOptions|boolean|function} requireAuth 
     * @param {Param[]|function} params 
     * @param {string|function} description 
     * @param {function} callback 
     */

  }, {
    key: "get",
    value: function get(version, route, requireAuth, params, docs, callback) {
      return this.registerRoute('get', version, route, requireAuth, params, docs, callback);
    }
    /**
     * 
     * @param {number} version 
     * @param {string} route 
     * @param {import('./').IRouteOptions|boolean|function} requireAuth 
     * @param {Param[]|function} params 
     * @param {string|function} description 
     * @param {function} callback 
     */

  }, {
    key: "post",
    value: function post(version, route, requireAuth, params, docs, callback) {
      return this.registerRoute('post', version, route, requireAuth, params, docs, callback);
    }
    /**
     * 
     * @param {number} version 
     * @param {string} route 
     * @param {import('./').IRouteOptions|boolean|function} requireAuth 
     * @param {Param[]|function} params 
     * @param {string|function} description 
     * @param {function} callback 
     */

  }, {
    key: "put",
    value: function put(version, route, requireAuth, params, docs, callback) {
      return this.registerRoute('put', version, route, requireAuth, params, docs, callback);
    }
    /**
     * 
     * @param {number} version 
     * @param {string} route 
     * @param {import('./').IRouteOptions|boolean|function} requireAuth 
     * @param {Param[]|function} params 
     * @param {string|function} description 
     * @param {function} callback 
     */

  }, {
    key: "delete",
    value: function _delete(version, route, requireAuth, params, docs, callback) {
      return this.registerRoute('delete', version, route, requireAuth, params, docs, callback);
    }
    /**
     * 
     * @param {number} version 
     * @param {string} route 
     * @param {import('./').IRouteOptions|boolean|function} requireAuth 
     * @param {Param[]|function} params 
     * @param {string|function} description 
     * @param {function} callback 
     */

  }, {
    key: "head",
    value: function head(version, route, requireAuth, params, docs, callback) {
      return this.registerRoute('head', version, route, requireAuth, params, docs, callback);
    } // #endregion

    /**
     * 
     * @param {string} method 
     * @param {number} version 
     * @param {string} route 
     * @param {import('./').IRouteOptions|boolean|function} requireAuth 
     * @param {Param[]|function} params 
     * @param {string|function} description 
     * @param {function} callback 
     */

  }, {
    key: "registerRoute",
    value: function registerRoute(method, version, route, requireAuth, params, description, callback) {
      if (isNaN(parseFloat(version))) {
        callback = description;
        description = params;
        params = requireAuth;
        requireAuth = route;
        route = version;
        version = null;
      } // Mismatch for back compatibility. If the requireAuth parameter is a function it means that it's the callback and RouteOptions are empty.


      if (typeof requireAuth === 'function') {
        params = requireAuth;
        requireAuth = {};
      }

      if (_typeof(requireAuth) === 'object') {
        // Mismatch for back compatibility. If the requireAuth parameter is an object it means that the callback is next argument (params).
        return this._registerRoute(method, version, route, _objectSpread(_objectSpread({}, requireAuth), {}, {
          timeout: requireAuth.timeout === undefined ? this._options.timeout : requireAuth.timeout
        }), params);
      }

      this._warn('Using endpoint options as method arguments is deprecated. It will be removed in next major release.');

      if (typeof params === 'function') {
        callback = params;
        params = [];
        description = null;
      }

      if (typeof description === 'function') {
        callback = description;
        description = null;
      }

      return this._registerRoute(method, version, route, {
        requireAuth: requireAuth,
        params: params,
        description: description,
        timeout: this._options.timeout
      }, callback);
    }
    /**
     * 
     * @param {function} cb 
     * @deprecated
     */

  }, {
    key: "listen",
    value: function listen() {
      var cb = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
      this.start(cb);
    }
    /**
     * Starts the application.
     * @param {function} cb 
     */

  }, {
    key: "start",
    value: function start() {
      var _this2 = this;

      var cb = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
      var _this$_options = this._options,
          port = _this$_options.port,
          auth = _this$_options.auth,
          log = _this$_options.log,
          errorKey = _this$_options.errorKey,
          errorStack = _this$_options.errorStack;

      for (var _i = 0, _Object$values = Object.values(this._routes); _i < _Object$values.length; _i++) {
        var route = _Object$values[_i];

        var _loop = function _loop() {
          var v = _Object$keys[_i2];
          var endpoint = route.routes[v];

          _this2._app[route.method](endpoint.getEndpoint(), /*#__PURE__*/function () {
            var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next) {
              var b, timeout, timedOut, data;
              return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      req.__endpoint = endpoint;
                      b = req.__benchmark;
                      timedOut = false;

                      if (endpoint.timeout) {
                        timeout = setTimeout(function () {
                          timedOut = true;
                          req.emit('timeout');
                          next(new _timeout["default"]());
                        }, endpoint.timeout);
                      }

                      b.mark('bootstrap');
                      _context.prev = 5;
                      _context.next = 8;
                      return _this2._checkApiKey(req);

                    case 8:
                      if (!timedOut) {
                        _context.next = 10;
                        break;
                      }

                      throw new _smartError["default"]('Time out', '_timeout_internal');

                    case 10:
                      b.mark('api key checking');
                      _context.next = 13;
                      return _this2._checkAuth(req, res, endpoint.auth, auth);

                    case 13:
                      if (!timedOut) {
                        _context.next = 15;
                        break;
                      }

                      throw new _smartError["default"]('Time out', '_timeout_internal');

                    case 15:
                      b.mark('auth checking');
                      _context.next = 18;
                      return _this2._checkArguments(endpoint.getArguments(), req);

                    case 18:
                      if (!timedOut) {
                        _context.next = 20;
                        break;
                      }

                      throw new _smartError["default"]('Time out', '_timeout_internal');

                    case 20:
                      b.mark('arguments checking');
                      _context.next = 23;
                      return _this2._checkParams(endpoint.params, req);

                    case 23:
                      if (!timedOut) {
                        _context.next = 25;
                        break;
                      }

                      throw new _smartError["default"]('Time out', '_timeout_internal');

                    case 25:
                      b.mark('params checking');
                      _context.next = 28;
                      return _this2._beforeCallback(req, res);

                    case 28:
                      if (!timedOut) {
                        _context.next = 30;
                        break;
                      }

                      throw new _smartError["default"]('Time out', '_timeout_internal');

                    case 30:
                      b.mark('before callback executing');
                      _context.next = 33;
                      return _this2._execute(req, res);

                    case 33:
                      data = _context.sent;

                      if (!timedOut) {
                        _context.next = 36;
                        break;
                      }

                      throw new _smartError["default"]('Time out', '_timeout_internal');

                    case 36:
                      b.mark('callback executed');
                      clearTimeout(timeout);

                      _this2._handleData(req, res, data);

                      _context.next = 52;
                      break;

                    case 41:
                      _context.prev = 41;
                      _context.t0 = _context["catch"](5);
                      clearTimeout(timeout);
                      _context.t1 = _context.t0.code;
                      _context.next = _context.t1 === 'ERR_NOT_FOUND' ? 47 : _context.t1 === 'ERR__TIMEOUT_INTERNAL' ? 49 : 50;
                      break;

                    case 47:
                      res.send404();
                      return _context.abrupt("break", 51);

                    case 49:
                      return _context.abrupt("break", 51);

                    case 50:
                      next(_context.t0);

                    case 51:
                      return _context.abrupt("return");

                    case 52:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee, null, [[5, 41]]);
            }));

            return function (_x, _x2, _x3) {
              return _ref4.apply(this, arguments);
            };
          }());
        };

        for (var _i2 = 0, _Object$keys = Object.keys(route.routes); _i2 < _Object$keys.length; _i2++) {
          _loop();
        }
      }

      this._app.use('*', /*#__PURE__*/function () {
        var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(req, res, next) {
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.prev = 0;
                  _context2.next = 3;
                  return _this2._checkApiKey(req);

                case 3:
                  _context2.next = 9;
                  break;

                case 5:
                  _context2.prev = 5;
                  _context2.t0 = _context2["catch"](0);
                  next(_context2.t0);
                  return _context2.abrupt("return");

                case 9:
                  res.send404();

                case 10:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, null, [[0, 5]]);
        }));

        return function (_x4, _x5, _x6) {
          return _ref5.apply(this, arguments);
        };
      }()); // TODO why the hell the next must be here if it's not needed?


      this._app.use(function (err, req, res, next) {
        var b = req.__benchmark;

        if (!(err instanceof _httpSmartError["default"])) {
          err = _httpSmartError["default"].create(err.statusCode || 500, err);
        }

        _this2._error("".concat(err.message).concat(log.stack ? "\n".concat(err.stack) : ''));

        b.mark('error logging');

        if (req.__endpoint) {
          var errors = Object.keys(req.__endpoint.getErrors());

          if (!errors.includes(err.code)) {
            _this2._warn("Error code '".concat(err.code, "' is not defined in the endpoint's error list."));
          }
        }

        res.status(err.statusCode);
        delete err.statusCode;
        var errorData = err.toJSON(errorStack);

        if (errorData.stack) {
          errorData.stack = errorData.stack.split('\n');
        }

        res._sendData(errorData, errorKey);
      });

      this._server = this._app.listen(port, function () {
        _this2._log("The application is listening on ".concat(port, ". Stats: ").concat(JSON.stringify(_this2._stats), "."));

        if (typeof cb === 'function') {
          cb(undefined, {
            stats: _this2._stats
          });
        }
      });
    }
    /**
     * Stops the application.
     * @param {function} cb 
     */

  }, {
    key: "stop",
    value: function stop() {
      var _this3 = this;

      var cb = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};

      if (!this._server) {
        this._warn('Server cannot be stopped because it was not started.');

        return;
      }

      this._server.close(function () {
        _this3._log('The application is stopped.');

        if (typeof cb === 'function') {
          cb();
        }
      });
    }
  }, {
    key: "docs",
    value: function () {
      var _docs = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var apiKey,
            docs,
            _i3,
            _Object$values2,
            route,
            _i4,
            _Object$keys2,
            v,
            endpoint,
            _args3 = arguments;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                apiKey = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : null;
                docs = {};
                _i3 = 0, _Object$values2 = Object.values(this._routes);

              case 3:
                if (!(_i3 < _Object$values2.length)) {
                  _context3.next = 25;
                  break;
                }

                route = _Object$values2[_i3];
                _i4 = 0, _Object$keys2 = Object.keys(route.routes);

              case 6:
                if (!(_i4 < _Object$keys2.length)) {
                  _context3.next = 22;
                  break;
                }

                v = _Object$keys2[_i4];
                endpoint = route.routes[v];

                if (!endpoint.hideDocs) {
                  _context3.next = 11;
                  break;
                }

                return _context3.abrupt("continue", 19);

              case 11:
                _context3.t0 = apiKey;

                if (!_context3.t0) {
                  _context3.next = 16;
                  break;
                }

                _context3.next = 15;
                return endpoint.isApiKeyExcluded(apiKey);

              case 15:
                _context3.t0 = _context3.sent;

              case 16:
                if (!_context3.t0) {
                  _context3.next = 18;
                  break;
                }

                return _context3.abrupt("continue", 19);

              case 18:
                docs["".concat(route.method.toUpperCase(), " ").concat(endpoint.getEndpoint())] = this._getDocsObject(endpoint);

              case 19:
                _i4++;
                _context3.next = 6;
                break;

              case 22:
                _i3++;
                _context3.next = 3;
                break;

              case 25:
                return _context3.abrupt("return", docs);

              case 26:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function docs() {
        return _docs.apply(this, arguments);
      }

      return docs;
    }()
  }, {
    key: "getDocs",
    value: function getDocs() {
      var docs = {};

      for (var _i5 = 0, _Object$values3 = Object.values(this._routes); _i5 < _Object$values3.length; _i5++) {
        var route = _Object$values3[_i5];

        for (var _i6 = 0, _Object$keys3 = Object.keys(route.routes); _i6 < _Object$keys3.length; _i6++) {
          var v = _Object$keys3[_i6];
          var endpoint = route.routes[v];

          if (endpoint.hideDocs) {
            continue;
          }

          docs["".concat(route.method.toUpperCase(), " ").concat(endpoint.getEndpoint())] = this._getDocsObject(endpoint);
        }
      }

      return docs;
    }
    /**
     * 
     * @param {string} method 
     * @param {number} version 
     * @param {string} route 
     * @param {import('./').IRouteOptions} options
     * @param {function} callback 
     */

  }, {
    key: "_registerRoute",
    value: function _registerRoute(method, version, route, options, callback) {
      if (typeof options === 'function') {
        callback = options;
        options = {};
      }

      var key = "".concat(method).concat(route);

      if (!this._routes[key]) {
        this._routes[key] = new _route["default"](method, route, options.args);
      }

      if (options.response && !(options.response instanceof _response.BaseResponse)) {
        options.response = new _response.JSONResponse(options.response);
      }

      if (options.requireAuth !== undefined) {
        this._warn('Route option \'requireAuth\' is deprecated.');
      }

      if (options.auth === undefined) {
        options.auth = options.requireAuth ? _enums.RouteAuth.REQUIRED : _enums.RouteAuth.DISABLED;
      }

      delete options.requireAuth;
      var endpoint = new _endpoint["default"](this._routes[key], _objectSpread(_objectSpread({
        version: version
      }, options), {}, {
        callback: callback,
        validateParams: this._options.validateParams,
        apiKeyEnabled: options.requireApiKey === false ? false : this._isApiKeyEnabled()
      }));
      return endpoint;
    }
    /**
     * 
     * @param {express.Request} req
     * @returns {Promise<void>}
     */

  }, {
    key: "_checkApiKey",
    value: function () {
      var _checkApiKey2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(req) {
        var _this4 = this;

        var apiKey;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                if (!(req.__endpoint && !req.__endpoint.apiKeyEnabled)) {
                  _context6.next = 2;
                  break;
                }

                return _context6.abrupt("return");

              case 2:
                if (!(typeof this._apiKeyHandler === 'function')) {
                  _context6.next = 18;
                  break;
                }

                if (req.query.api_key) {
                  _context6.next = 5;
                  break;
                }

                throw new _missingApiKey["default"]();

              case 5:
                _context6.next = 7;
                return this._apiKeyHandler(req.query.api_key, req);

              case 7:
                if (_context6.sent) {
                  _context6.next = 9;
                  break;
                }

                throw new _invalidApiKey["default"]();

              case 9:
                req.apiKey = req.query.api_key;
                _context6.t0 = req.__endpoint;

                if (!_context6.t0) {
                  _context6.next = 15;
                  break;
                }

                _context6.next = 14;
                return req.__endpoint.isApiKeyExcluded(req.query.api_key);

              case 14:
                _context6.t0 = _context6.sent;

              case 15:
                if (!_context6.t0) {
                  _context6.next = 17;
                  break;
                }

                throw new _notFound["default"]();

              case 17:
                return _context6.abrupt("return");

              case 18:
                apiKey = this._options.apiKey;

                if (!(!apiKey || !apiKey.enabled)) {
                  _context6.next = 21;
                  break;
                }

                return _context6.abrupt("return");

              case 21:
                return _context6.abrupt("return", new Promise( /*#__PURE__*/function () {
                  var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(resolve, reject) {
                    var key, executed, p;
                    return regeneratorRuntime.wrap(function _callee5$(_context5) {
                      while (1) {
                        switch (_context5.prev = _context5.next) {
                          case 0:
                            key = null;
                            _context5.t0 = apiKey.type;
                            _context5.next = _context5.t0 === 'body' ? 4 : _context5.t0 === 'header' ? 6 : 8;
                            break;

                          case 4:
                            key = req.body.api_key;
                            return _context5.abrupt("break", 10);

                          case 6:
                            key = req.headers.api_key;
                            return _context5.abrupt("break", 10);

                          case 8:
                            key = req.query.api_key;
                            return _context5.abrupt("break", 10);

                          case 10:
                            if (key) {
                              _context5.next = 13;
                              break;
                            }

                            reject(new _missingApiKey["default"]());
                            return _context5.abrupt("return");

                          case 13:
                            req.apiKey = key;

                            if (!req.__endpoint) {
                              _context5.next = 27;
                              break;
                            }

                            _context5.prev = 15;
                            _context5.next = 18;
                            return req.__endpoint.isApiKeyExcluded(key);

                          case 18:
                            if (!_context5.sent) {
                              _context5.next = 21;
                              break;
                            }

                            reject(new _notFound["default"]());
                            return _context5.abrupt("return");

                          case 21:
                            _context5.next = 27;
                            break;

                          case 23:
                            _context5.prev = 23;
                            _context5.t1 = _context5["catch"](15);
                            reject(_context5.t1);
                            return _context5.abrupt("return");

                          case 27:
                            executed = false;

                            if (!apiKey.validator) {
                              apiKey.validator = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
                                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                                  while (1) {
                                    switch (_context4.prev = _context4.next) {
                                      case 0:
                                        return _context4.abrupt("return", true);

                                      case 1:
                                      case "end":
                                        return _context4.stop();
                                    }
                                  }
                                }, _callee4);
                              }));
                            }

                            p = apiKey.validator(key, function (err) {
                              _this4._warn('Using a callback in api key validator is deprecated.');

                              if (executed) {
                                _this4._warn('Middleware executed using a Promise.');

                                return;
                              }

                              executed = true;

                              if (err) {
                                reject(err);
                                return;
                              }

                              resolve();
                            });

                            if (p instanceof Promise) {
                              p.then(function (valid) {
                                if (executed) {
                                  _this4._warn('Middleware executed using a callback.');

                                  return;
                                }

                                if (typeof valid !== 'boolean') {
                                  _this4._warn('Api key validator should return Promise<boolean>.');

                                  return;
                                }

                                executed = true;

                                if (!valid) {
                                  reject(new _invalidApiKey["default"]());
                                  return;
                                }

                                resolve();
                              })["catch"](function (e) {
                                executed = true;
                                process.nextTick(function () {
                                  return reject(e);
                                });
                              });
                            }

                          case 31:
                          case "end":
                            return _context5.stop();
                        }
                      }
                    }, _callee5, null, [[15, 23]]);
                  }));

                  return function (_x8, _x9) {
                    return _ref6.apply(this, arguments);
                  };
                }()));

              case 22:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function _checkApiKey(_x7) {
        return _checkApiKey2.apply(this, arguments);
      }

      return _checkApiKey;
    }()
    /**
     * 
     * @param {express.Request} req 
     * @param {express.Response} res 
     * @param {RouteAuth} routeAuth 
     * @param {AppOptions.Auth} auth
     * @returns {Promise<void>}
     */

  }, {
    key: "_checkAuth",
    value: function _checkAuth(req, res, routeAuth, auth) {
      var _this5 = this;

      return new Promise(function (resolve, reject) {
        if (!routeAuth) {
          resolve();
          return;
        }

        var key = auth.key,
            validator = auth.validator;

        if (!req.headers[key]) {
          if (routeAuth === _enums.RouteAuth.OPTIONAL) {
            resolve();
            return;
          }

          reject(new _missingAccessToken["default"]());
          return;
        }

        req.accessToken = req.headers[key];
        var executed = false;
        var p = validator(key, req, res, function (err) {
          _this5._warn('Using a callback in auth validator is deprecated.');

          if (executed) {
            _this5._warn('Middleware executed using a Promise.');

            return;
          }

          executed = true;

          if (err) {
            reject(err);
            return;
          }

          resolve();
        });

        if (p instanceof Promise) {
          p.then(function (valid) {
            if (executed) {
              _this5._warn('Middleware executed using a callback.');

              return;
            }

            if (typeof valid !== 'boolean') {
              _this5._warn('Access token validator should return Promise<boolean>.');

              return;
            }

            executed = true;

            if (!valid) {
              reject(new _invalidAccessToken["default"]());
              return;
            }

            resolve();
          })["catch"](function (e) {
            executed = true;
            process.nextTick(function () {
              return reject(e);
            });
          });
        }
      });
    }
    /**
     * 
     * @param {Object.<string, Field>} args 
     * @param {express.Request} req 
     * @returns {Promise<void>}
     */

  }, {
    key: "_checkArguments",
    value: function _checkArguments(args, req) {
      return new Promise(function (resolve, reject) {
        try {
          Object.keys(args).forEach(function (key) {
            var arg = args[key];

            if (!arg.type.canCast(req.params[key])) {
              throw new _error2["default"].InvalidArgumentType(key, arg.type);
            }

            req.params[key] = arg.type.cast(req.params[key]);
          });
        } catch (err) {
          reject(err);
        }

        resolve();
      });
    }
    /**
     * 
     * @param {Param[]} params 
     * @param {express.Request} req
     * @returns {Promise<void>}
     */

  }, {
    key: "_checkParams",
    value: function _checkParams(params, req) {
      return new Promise(function (resolve, reject) {
        if (!params.length) {
          resolve();
          return;
        }

        var mergedParams = _objectSpread(_objectSpread({}, req.query), req.body);

        var castedParams = {};
        var paramsKey = req.method === 'GET' ? 'query' : 'body';

        try {
          params.forEach(function (param) {
            var p = param.name;

            if (param.required) {
              var requiredParam = req[paramsKey][p];

              if (requiredParam === null || requiredParam === undefined) {
                throw new _error2["default"].MissingParameter(p, {
                  parameter: p
                });
              }

              if (param.type.getName() === 'ArrayOf' && requiredParam instanceof Array && !requiredParam.length) {
                throw new _error2["default"].MissingParameter(p, true, {
                  parameter: p
                });
              }
            } else if (mergedParams[p] === undefined) {
              return;
            }

            try {
              castedParams[p] = param.type.cast(mergedParams[p]);
            } catch (e) {
              switch (e.code) {
                case 'ERR_INVALID_CAST':
                case 'ERR_UNSUPPORTED_OPERATION':
                  throw new _error2["default"].InvalidParameterType(p, param.type, {
                    type_error: {
                      message: e.message,
                      code: e.code
                    }
                  });

                default:
                  throw e;
              }
            }
          });
        } catch (err) {
          reject(err);
        }

        req[paramsKey] = _objectSpread(_objectSpread({}, req[paramsKey]), castedParams);
        resolve();
      });
    }
    /**
     * 
     * @param {express.Request} req 
     * @param {express.Response} res
     * @returns {Promise<void>}
     */

  }, {
    key: "_beforeCallback",
    value: function () {
      var _beforeCallback2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(req, res) {
        var i, _this$_beforeExecutio, spec, callback, r, match;

        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                if (!this._beforeExecution.length) {
                  _context7.next = 17;
                  break;
                }

                i = 0;

              case 2:
                if (!(i < this._beforeExecution.length)) {
                  _context7.next = 17;
                  break;
                }

                _this$_beforeExecutio = this._beforeExecution[i], spec = _this$_beforeExecutio.spec, callback = _this$_beforeExecutio.callback;

                if (!(spec === '*')) {
                  _context7.next = 8;
                  break;
                }

                _context7.next = 7;
                return callback(req, res);

              case 7:
                return _context7.abrupt("continue", 14);

              case 8:
                r = new _routeParser["default"](spec);
                match = r.match(req.path);

                if (match) {
                  _context7.next = 12;
                  break;
                }

                return _context7.abrupt("continue", 14);

              case 12:
                _context7.next = 14;
                return callback(req, res);

              case 14:
                i++;
                _context7.next = 2;
                break;

              case 17:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function _beforeCallback(_x10, _x11) {
        return _beforeCallback2.apply(this, arguments);
      }

      return _beforeCallback;
    }()
    /**
     * 
     * @param {express.Request} req 
     * @param {express.Response} res 
     * @returns {Promise<any>}
     */

  }, {
    key: "_execute",
    value: function _execute(req, res) {
      var _this6 = this;

      return new Promise(function (resolve, reject) {
        var endpoint = req.__endpoint;
        var dataSent = false;
        var p = endpoint.callback(req, res, function (err, data) {
          _this6._warn('Using callbacks in the endpoint execution is deprecated. Use Promises.');

          if (dataSent) {
            _this6._warn('Data already sent using a Promise.');

            return;
          }

          dataSent = true;

          if (err) {
            reject(err);
            return;
          }

          resolve(data);
        });

        if (p instanceof Promise) {
          p.then(function (data) {
            if (dataSent) {
              _this6._warn('Data already sent using a callback.');

              return;
            }

            if (data === undefined) {
              _this6._warn('Methods using Promises shouldn\'t return undefined.');

              return;
            }

            dataSent = true;
            resolve(data);
          })["catch"](function (e) {
            dataSent = true;
            reject(e); // TODO? process.nextTick
          });
        }
      });
    }
    /**
     * Validates the data with defined response of the endpoint. After the validation the data are sent to output.
     * @param {express.Request} req 
     * @param {express.Response} res 
     * @param {any} data 
     */

  }, {
    key: "_handleData",
    value: function _handleData(req, res, data) {
      var _this7 = this;

      var wrapArrayResponse = this._options.wrapArrayResponse;
      var endpoint = req.getEndpoint();

      if (wrapArrayResponse && data instanceof Array) {
        data = {
          count: data.length,
          items: data
        };
      }

      var responseData;

      if (endpoint.response) {
        if (!data) {
          this._warn('Endpoint has defined response data but the callback is sending undefined data.');
        } else {
          if (endpoint.response instanceof _response.JSONResponse) {
            try {
              // convert data to json
              responseData = data.toJSON();
            } catch (e) {
              this._warn('Data do not have toJSON method.'); // if data don't have toJSON method copy the data to new object


              responseData = _objectSpread({}, data);
            }

            endpoint.response.fields.forEach(function (field) {
              var type = field.type,
                  name = field.name;

              try {
                responseData[name] = type.cast(responseData[name]);
              } catch (e) {
                var message = "Response on key '".concat(name, "' has invalid type. It should be ").concat(type, ".");

                if (_this7._options.responseStrictValidation) {
                  throw new _smartError["default"](message, 'invalid_response_cast', {
                    type_error: e.toJSON()
                  });
                }

                _this7._warn("".concat(message, " -> ").concat(e.message));
              }
            });
          }
        }
      }

      res._sendData(responseData || data);
    }
  }, {
    key: "_afterCallback",
    value: function () {
      var _afterCallback2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(err, data, req, res) {
        var i, _this$_afterExecution, spec, callback, r, match;

        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                if (!this._afterExecution.length) {
                  _context8.next = 17;
                  break;
                }

                i = 0;

              case 2:
                if (!(i < this._afterExecution.length)) {
                  _context8.next = 17;
                  break;
                }

                _this$_afterExecution = this._afterExecution[i], spec = _this$_afterExecution.spec, callback = _this$_afterExecution.callback;

                if (!(spec === '*')) {
                  _context8.next = 8;
                  break;
                }

                _context8.next = 7;
                return callback(err, data, req, res);

              case 7:
                return _context8.abrupt("continue", 14);

              case 8:
                r = new _routeParser["default"](spec);
                match = r.match(req.path);

                if (match) {
                  _context8.next = 12;
                  break;
                }

                return _context8.abrupt("continue", 14);

              case 12:
                _context8.next = 14;
                return callback(err, data, req, res);

              case 14:
                i++;
                _context8.next = 2;
                break;

              case 17:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function _afterCallback(_x12, _x13, _x14, _x15) {
        return _afterCallback2.apply(this, arguments);
      }

      return _afterCallback;
    }()
    /**
     * Creates the express application instance and registers middlewares.
     */

  }, {
    key: "_createApp",
    value: function _createApp() {
      var _this8 = this;

      var _this$_options2 = this._options,
          defaultError = _this$_options2.defaultError,
          dataKey = _this$_options2.dataKey,
          errorKey = _this$_options2.errorKey,
          requestLimit = _this$_options2.requestLimit,
          meta = _this$_options2.meta,
          log = _this$_options2.log,
          logger = _this$_options2.logger,
          name = _this$_options2.name,
          charset = _this$_options2.charset;
      this._app = (0, _express["default"])();

      this._app.use(function (req, res, next) {
        var benchmark = new _benchmark["default"]().start();
        req.__benchmark = benchmark;

        req.getEndpoint = function () {
          return req.__endpoint;
        };

        req.getBenchmark = function () {
          return req.__benchmark;
        };

        res.send204 = function () {
          _this8._warn('res.send204 is deprecated. Use next callback in the route without data.');

          res._sendData();
        };

        res.send404 = function () {
          var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Page not found';
          var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'page_not_found';
          return res.sendError(_httpSmartError["default"].create(404, message, code));
        };

        res.send401 = function (message, code) {
          return res.sendError(_httpSmartError["default"].create(401, message, code));
        };

        res.send501 = function (message, code) {
          return res.sendError(_httpSmartError["default"].create(501, message, code));
        };

        res.addMeta = function (key, value) {
          if (!res.__meta) {
            res.__meta = {};
          }

          res.__meta[key] = value;
        };

        res.sendError = function () {
          var code = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultError.statusCode;
          var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : defaultError.message;
          var errorCode = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultError.code;

          if (code instanceof _httpSmartError["default"]) {
            next(code);
            return;
          }

          _this8._warn('res.sendError is deprecated with using status codes, message and errorCode. Use HttpError instance.');

          next(new _smartError["default"](message, errorCode));
        };

        res.sendData = function (data) {
          var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : dataKey;

          _this8._warn('res.sendData is deprecated. Use next callback in route or Promises.');

          res._sendData(data, key);
        };

        res._sendData = /*#__PURE__*/function () {
          var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(data) {
            var key,
                _args9 = arguments;
            return regeneratorRuntime.wrap(function _callee9$(_context9) {
              while (1) {
                switch (_context9.prev = _context9.next) {
                  case 0:
                    key = _args9.length > 1 && _args9[1] !== undefined ? _args9[1] : dataKey;
                    _context9.prev = 1;
                    _context9.next = 4;
                    return _this8._afterCallback(key === errorKey, data, req, res);

                  case 4:
                    _context9.next = 10;
                    break;

                  case 6:
                    _context9.prev = 6;
                    _context9.t0 = _context9["catch"](1);
                    process.nextTick(function () {
                      return next(_context9.t0);
                    });
                    return _context9.abrupt("return");

                  case 10:
                    res._end(data !== undefined && data !== null ? _defineProperty({}, key, data) : null);

                  case 11:
                  case "end":
                    return _context9.stop();
                }
              }
            }, _callee9, null, [[1, 6]]);
          }));

          return function (_x16) {
            return _ref8.apply(this, arguments);
          };
        }();

        res._end = function (data) {
          var body = req.body;

          if (JSON.stringify(body).length > 1024) {
            body = 'Body too long';
          }

          benchmark.mark('data handled');
          var took = benchmark.total;
          var endpoint = req.getEndpoint();
          var deprecated = false;

          if (data) {
            if (endpoint && endpoint.isDeprecated()) {
              deprecated = true;
              data.warning = 'This endpoint is deprecated. It can be removed in the future.';
            }

            if (meta.enabled && req.query.nometa === undefined) {
              data._meta = _lodash["default"].merge({
                took: took,
                deprecated: deprecated || undefined,
                rs: {
                  version: _package["default"].version,
                  module: "https://www.npmjs.com/package/".concat(_package["default"].name)
                },
                request: {
                  endpoint: "".concat(req.method, " ").concat(req.path),
                  body: body,
                  query: req.query,
                  headers: req.headers
                },
                app: {
                  name: name,
                  version: APP_PACKAGE.version
                } // benchmark,

              }, meta.data);

              if (_typeof(res.__meta) === 'object') {
                Object.keys(res.__meta).forEach(function (key) {
                  return data._meta[key] = res.__meta[key];
                });
              }
            } // res.header('Content-Type', `application/json; charset=${charset}`);
            // TODO check in what cases isn't endpoint set


            var response = endpoint && endpoint.response ? data[errorKey] ? new _response.JSONResponse() : endpoint.response : new _response.JSONResponse();
            res.header('Content-Type', response.getContentType(charset));
            var responseHeaders = response.getHeaders() || {};
            Object.keys(responseHeaders).forEach(function (key) {
              res.header(key, responseHeaders[key]);
            }); // const json = JSON.stringify(data, null, req.query.pretty === undefined ? 0 : 4);

            res.write(response.getData(data, req.query.pretty));
          } else {
            res.status(204);
          }

          res.end();

          if (log.enabled && typeof logger === 'function' && req.path !== '/ping') {
            logger({
              statusCode: res.statusCode,
              method: req.method,
              path: req.path,
              spec: req.route ? req.route.path : req.path,
              body: req.body,
              params: req.params,
              query: req.query,
              headers: req.headers,
              took: took,
              response: data
            }, req);
          }
        };

        next();
      });

      this._app.use((0, _compression["default"])());

      this._app.use(_bodyParser["default"].json({
        limit: requestLimit
      }));
    }
    /**
     * Registers the /favicion.ico, /ping and /docs* routes.
     */

  }, {
    key: "_registerSupportRoutes",
    value: function _registerSupportRoutes() {
      var _this9 = this;

      var _this$_options3 = this._options,
          docs = _this$_options3.docs,
          name = _this$_options3.name,
          charset = _this$_options3.charset;
      this.use('/favicon.ico', function (req, res) {
        res.status(204);
        res.end();
      });
      this.get('/ping', {
        hideDocs: true
      }, function (req, res, next) {
        return next(null, 'pong');
      });

      if (docs.enabled) {
        var requireAuth = false;

        if (docs.auth) {
          this._warn('Using auth on docs is deprecated. Use api key and its validation instead.');

          requireAuth = true;
        }

        this.get(docs.route, {
          requireAuth: requireAuth,
          description: 'Documentation of this API.',
          hideDocs: true
        }, function (_ref10) {
          var apiKey = _ref10.apiKey;
          return _this9.docs(apiKey);
        });
        this.get("".concat(docs.route, "-legacy.html"), {
          requireAuth: requireAuth,
          hideDocs: true,
          response: new _response.CustomResponse("text/html; charset=".concat(charset))
        }, function (req, res, next) {
          _fs["default"].readFile(_path["default"].resolve(__dirname, '../assets/docs-legacy.html'), function (err, buffer) {
            if (err) {
              next(err);
              return;
            }

            var html = buffer.toString();
            var vars = {
              name: name,
              apiKey: _this9._isApiKeyEnabled() ? req.query.api_key : '',
              rsVersion: _package["default"].version,
              version: APP_PACKAGE.version,
              dataKey: _this9._options.dataKey,
              errorKey: _this9._options.errorKey,
              meta: _this9._options.meta.enabled,
              authKey: _this9._options.auth.key,
              authDescription: _this9._options.auth.description || '',
              docsRoute: _this9._options.docs.route
            };
            Object.keys(vars).forEach(function (key) {
              var r = new RegExp("\\$\\{".concat(key, "\\}"), 'g');
              html = html.replace(r, vars[key]);
            });
            next(null, html);
          });
        });
        this.get("".concat(docs.route, ".html"), {
          requireAuth: requireAuth,
          hideDocs: true,
          response: new _response.CustomResponse("text/html; charset=".concat(charset))
        }, function (req, res, next) {
          _fs["default"].readFile(_path["default"].resolve(__dirname, '../assets/docs.html'), function (err, buffer) {
            if (err) {
              next(err);
              return;
            }

            var html = buffer.toString();
            var vars = {
              name: name,
              apiKey: _this9._isApiKeyEnabled() ? req.query.api_key : '',
              data: JSON.stringify({
                name: name,
                apiKey: _this9._isApiKeyEnabled() ? req.query.api_key : null,
                rsVersion: _package["default"].version,
                version: APP_PACKAGE.version,
                dataKey: _this9._options.dataKey,
                errorKey: _this9._options.errorKey,
                meta: _this9._options.meta.enabled,
                authKey: _this9._options.auth.key,
                authDescription: _this9._options.auth.description || '',
                docsRoute: _this9._options.docs.route
              })
            };
            Object.keys(vars).forEach(function (key) {
              var r = new RegExp("\\$\\{".concat(key, "\\}"), 'g');
              html = html.replace(r, vars[key]);
            });
            next(null, html);
          });
        });
        this.get("".concat(docs.route, ".js"), {
          hideDocs: true,
          response: new _response.CustomResponse("text/javascript; charset=".concat(charset))
        }, function (req, res, next) {
          _fs["default"].readFile(_path["default"].resolve(__dirname, '../assets/docs.js'), next);
        });
        this.get('/bundle.js', {
          hideDocs: true,
          response: new _response.CustomResponse("text/javascript; charset=".concat(charset))
        }, function (req, res, next) {
          _fs["default"].readFile(_path["default"].resolve(__dirname, '../assets/bundle.js'), next);
        });
        this.get("".concat(docs.route, ".css"), {
          hideDocs: true,
          response: new _response.CustomResponse("text/css; charset=".concat(charset))
        }, function (req, res, next) {
          _fs["default"].readFile(_path["default"].resolve(__dirname, '../assets/docs.css'), next);
        });
      }
    }
    /**
     * 
     * @param {Endpoint} endpoint 
     */

  }, {
    key: "_getDocsObject",
    value: function _getDocsObject(endpoint) {
      return {
        docs: endpoint.docs,
        description: endpoint.description,
        args: endpoint.getArguments(),
        params: endpoint.getParams(this._options.docs.paramsAsArray),
        required_params: endpoint.requiredParams,
        required_auth: endpoint.requiredAuth,
        auth: endpoint.getAuth(),
        response: endpoint.getResponse(),
        response_type: endpoint.getResponseType(this._options.charset),
        errors: endpoint.getErrors(),
        deprecated: endpoint.isDeprecated()
      };
    }
  }, {
    key: "_mergeObjects",
    value: function _mergeObjects(o1, o2) {
      var _this10 = this;

      var strict = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var o = {};

      if (!strict) {
        Object.keys(o1).forEach(function (k) {
          if (o2[k] === undefined) {
            o[k] = o1[k];
          }
        });
      }

      Object.keys(o2).forEach(function (k) {
        var v = o2[k];

        if (o1[k] === undefined) {
          o[k] = v;
          return;
        }

        if (_typeof(v) !== 'object' || v === null) {
          o[k] = o1[k];
          return;
        }

        o[k] = _this10._mergeObjects(o1[k], v, ['before', 'after'].indexOf(k) < 0);
      });
      return o;
    }
  }, {
    key: "_isApiKeyEnabled",
    value: function _isApiKeyEnabled() {
      var apiKey = this._options.apiKey;

      if (typeof this._apiKeyHandler === 'function') {
        return true;
      }

      return apiKey && apiKey.enabled;
    }
  }, {
    key: "_log",
    value: function _log(message) {
      var _this$_options$log = this._options.log,
          enabled = _this$_options$log.enabled,
          level = _this$_options$log.level;

      if (enabled && ['verbose'].includes(level)) {
        console.log(new Date(), message);
      }
    }
  }, {
    key: "_warn",
    value: function _warn(message) {
      var _this$_options$log2 = this._options.log,
          enabled = _this$_options$log2.enabled,
          level = _this$_options$log2.level;

      if (enabled && ['warn', 'verbose'].includes(level)) {
        console.warn(new Date(), message);
      }

      this._stats.warning++;
    }
  }, {
    key: "_error",
    value: function _error(message) {
      var _this$_options$log3 = this._options.log,
          enabled = _this$_options$log3.enabled,
          level = _this$_options$log3.level;

      if (enabled && ['error', 'warn', 'verbose'].includes(level)) {
        console.error(new Date(), message);
      }

      this._stats.error++;
    }
  }]);

  return Application;
}();
/**
 * 
 * @param {import('./').IAppOptions} options 
 * @deprecated
 */


exports.Application = Application;

var m = function m() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return new Application(options);
};

exports["default"] = m;