"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _runtimeType = _interopRequireDefault(require("runtime-type"));

var _field = _interopRequireDefault(require("./endpoint/field"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Route = /*#__PURE__*/function () {
  function Route(method, route) {
    var _this = this;

    var args = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

    _classCallCheck(this, Route);

    _defineProperty(this, "method", null);

    _defineProperty(this, "route", null);

    _defineProperty(this, "routes", {});

    _defineProperty(this, "args", {});

    this.method = method;
    this.route = route;
    this.args = this._getArgs();
    args.forEach(function (arg) {
      return _this.args[arg.name] = arg;
    });
  }

  _createClass(Route, [{
    key: "addEndpoint",
    value: function addEndpoint(endpoint) {
      this.routes[endpoint.version] = endpoint;
      endpoint.route = this;
    }
  }, {
    key: "getMaxVersion",
    value: function getMaxVersion() {
      var max = Math.max.apply(null, Object.keys(this.routes));

      if (isNaN(max)) {
        return null;
      }

      return max;
    }
  }, {
    key: "getArguments",
    value: function getArguments() {
      var _this2 = this;

      var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (array) {
        return Object.keys(this.args).map(function (arg) {
          return _this2.args[arg];
        });
      }

      return this.args;
    }
  }, {
    key: "_getArgs",
    value: function _getArgs() {
      var args = {};
      (this.route.match(/(:\w+)/g) || []).map(function (m) {
        return m.substr(1);
      }).forEach(function (param) {
        return args[param] = new _field["default"](param, _runtimeType["default"].any);
      });
      return args;
    }
  }]);

  return Route;
}();

exports["default"] = Route;